/**
 * Un oggetto della classe <code>ErreQuattro</code> rappresenta
 * un elemento dello spazio vettoriale R^4
 * @author Alessandra Di Pierro
 */
package jad.vettori;

public class ErreQuattro extends ErreTre  {
  // CAMPI

    private double w; // quarta coordinata

  // ZERO e' creato dall JVM quando viene eseguita la
  // prima istruzione che contiene il nome
  // della classe (ErreTRe)
    public static final ErreQuattro ZERO = new ErreQuattro(0,0,0,0);

  // COSTRUTTORI
  /**
   * Costruisce un nuovo vettore nello spazio R^4
   */
    public ErreQuattro(double x, double y, double z, double w) {
	super(x,y,z);
	this.w = w;
  }


  // METODI

   public ErreQuattro piu(ErreQuattro v) {
       ErreTre t = new ErreTre(this.x, this.y, this.z);
       super.piu(v);
       double nw = this.w + v.w;

       return new ErreQuattro(t.x,t.y,t.z,nw);
   }

    public boolean equals(ErreTre v) {
	return this.x == v.x && this.y == v.y && this.z == v.z;
    }

    public String toString() {
	return "<"+ super.x +" , "+ super.y +" , "+ super.z +" , "+ 
	    "this.w" +" > ";
    }

}
